;*******************************************Handle Block Explosion
;*
;*	This functions handles a block explosion(when a block explodes)
;*
;*	Input	d6=the bexp explosion # in the array
;*
;*********
handle_bexp:
	lea	bomblib::bexp_x,a0		;Get bexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomblib::bexp_y,a0		;Get bexp d6's y
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	bomblib::bexp_s,a0		;Get bexp d6's s
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s

	;cmp.w	#0,s
	;beq		delete_bexp
	;cmp.w	#5,s
	;bhi		delete_bexp

	move.w	x,d0			;clear the screen under the bexp
	move.w	y,d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_bexp

	;move.w	x,(a2)
	;move.w	y,(a3)
	move.w	s,(a4)

	cmp.w	#1,s			;draw the bexp sprite
	beq		hbe_s1
	cmp.w	#2,s
	beq		hbe_s2
	cmp.w	#3,s
	beq		hbe_s3
	cmp.w	#4,s
	beq		hbe_s4
	bra		delete_bexp
hbe_exit:
	rts

hbe_s1:
	PutGray4Sprite sprite_bexp40,sprite_bexp41,x,y
	rts

hbe_s2:
	PutGray4Sprite sprite_bexp30,sprite_bexp31,x,y
	rts

hbe_s3:
	PutGray4Sprite sprite_bexp20,sprite_bexp21,x,y
	rts

hbe_s4:
	PutGray4Sprite sprite_bexp10,sprite_bexp11,x,y
	rts

;*******************************************Delete Block Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the bexp array
;*
;*********
delete_bexp:

	movem.l	d0/a0-a2,-(a7)

	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoard	#0

	lea	bomblib::bexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomblib::bexp_y,a1
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a1,d0.w),a1

	lea	bomblib::bexp_s,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	move.w	bomblib::bexpcount,d0
	sub.w	d6,d0
	cmp.w	#0,d0
	beq		dbe_loop_exit
	subq.w	#1,d0

		;this code shifts the array starting at the bexp #
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
dbe_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2

	dbra.w	d0,dbe_loop

dbe_loop_exit:
	subq.w	#1,bomblib::bexpcount

	movem.l	(a7)+,d0/a0-a2
	rts

;*******************************************Add Block Explosion
;*
;*	This functions adds a block explosion to the bexp array
;*
;*	Input:	x=x coordinate(in squares) of the new bexp
;*		y=y coordinate(in squares) of the new bexp
;*
;*********
add_bexp:
	movem.l	d0-d4/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	SetBoard #0

		;check if a bonus should be placed or not
	cmp.w	#1,d2
	bne		add_bexp_no_bonus
	Random  bomblib::bonus_possibility,d3	;IF (RND*8=1)
	cmp.w	#9,d3
	bcc		add_bexp_no_bonus
	move.w	d3,t
	move.w	#0,tmp2
	bsr		add_bonus
	add_bexp_no_bonus:

	lea	bomblib::bexp_x,a0		;Set bexp x
	move.w  bomblib::bexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::bexp_y,a0		;Set bexp y
	move.w  bomblib::bexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::bexp_s,a0		;Set bexp s
	move.w  bomblib::bexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomblib::explife,d2	;the sprite has a life one less than a regular exp.
	subq.w	#1,d2
	move.w	d2,(a0)

	addq.w	#1,bomblib::bexpcount

	movem.l	(a7)+,d0-d4/a0
	rts