;*******************************************Draw Board
;*
;*	This functions is called to draw the entire board from left to right
;*
;*********
draw_board:
		move.w	#0,d0		;FOR x=0 to 12
db_for_x_2:

	move.w	#0,d1			;FOR y=0 to 9
db_for_y_2:

	GetBoard d4			;IF board(x*10+y)=1 then

	move.w	d0,d2			;x*9+6
	mulu.w	#9,d2
	addq.w	#5,d2

	move.w	d1,d3			;y*9+6
	mulu.w	#9,d3
	addq.w	#5,d3

	cmp.w	#1,d4
	bne	db_end_if_3

	PutGray4Sprite sprite_block0a,sprite_block1a,d2,d3

db_end_if_3:				;END IF

	cmp.w	#2,d4			;IF board(x*10+y)=2 then
	bne	db_end_if_4

	PutGray4Sprite sprite_block0b,sprite_block1b,d2,d3

db_end_if_4:

	addq.w	#1,d1			;NEXT y
	cmp.w	#10,d1
	bne	db_for_y_2	

	addq.w	#1,d0			;NEXT x
	cmp.w	#13,d0
	bne	db_for_x_2

	rts

;*******************************************Draw Board One
;*
;*	This functions is called to draw one piece of the board
;*
;*	Input: 	d0=x position(0-12)
;*		d1=y position(0-9)
;*	
;*********

draw_board_one:
	GetBoard d4			;IF board(boardpos)<>0 then
	cmp.w	#0,d4
	beq	db1_end_if_2
	move.w	d0,d2			;x*9+5	(this is the code to 
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d1,d3			;y*9+5
	mulu.w	#9,d3
	addq.w	#5,d3
	cmp.w	#1,d4
	bne	db1_end_if
	PutGray4Sprite sprite_block0a,sprite_block1a,d2,d3
	bra	db1_end_if_2
db1_end_if:				;END IF
	cmp.w	#2,d4			;IF board(x*10+y)=2 then
	bne	db1_end_if_2
	PutGray4Sprite sprite_block0b,sprite_block1b,d2,d3
	bra	db1_end_if_2

db1_end_if_2:				;END IF
	rts

;*******************************************Clear Board
;*
;*	This functions clears the board array, settin it to zero (not used)
;*
;*********
clear_board:
	lea	bomblib::board,a0
	move.w	#139,d0
clear_board_loop:
	move.w	#0,(a0)+
	dbra.w	d0,clear_board_loop
	rts
	
;*******************************************Generate Random Board
;*
;*	This functions generates a random board for a "random" game
;*
;*********
generate_random_board:

	move.w	#0,d0			;FOR x=0 to 12
grb_for_x_1:

	move.w	#0,d1			;FOR y=0 to 9
grb_for_y_1:
	
	SetBoard #0		;LET board(x*10+y)=0

	move.w	d1,d2			;LET tmp=int((y-1)/2)*2+1
	subq.w	#1,d2
	divu.w	#2,d2
	mulu.w	#2,d2
	addq.w	#1,d2

	move.w	d0,d3			;LET tmpx=int((x-1)/2)*2+1
	subq.w	#1,d3
	divu.w	#2,d3
	mulu.w	#2,d3
	addq.w	#1,d3
	
	cmp.w	d1,d2			;IF y=tmp and x=tmpx then
	bne	grb_else_if_1
	cmp.w	d0,d3
	bne	grb_else_if_1

	SetBoard #2			;LET board(x*10+y)=2
	
	bra	grb_end_if_1

grb_else_if_1:
	move.w	d0,d3			;ELSE IF (y+x>3)
	add.w	d1,d3
	cmp.w	#2,d3
	bcs	grb_end_if_1

	Random  #3,d3			;IF (RND*3=1)
	cmp.w	#1,d3
	bne	grb_else_if_2

	SetBoard #1			;LET board(x*10+y)=1

	bra	grb_end_if_2

grb_else_if_2:
	
	Random  #15,d3			;IF (RND*8=1)
	cmp.w	#1,d3
	bne	grb_end_if_2
	
	move.w	d0,x
	move.w	d1,y
	move.w	#1,dir
	bsr	add_enemy1

grb_end_if_2:
grb_end_if_1:
	addq.w	#1,d1			;NEXT y
	cmp.w	#10,d1
	bne	grb_for_y_1	

	addq.w	#1,d0			;NEXT x
	cmp.w	#13,d0
	bne	grb_for_x_1

	cmp.w	#0,bomblib::enemy1count
	beq		generate_random_board
	rts

;*******************************************Generate Level Board
;*
;*	This functions generates a random board for a specific level
;*
;*********
generate_level_board:

	move.w	#0,d0			;FOR x=0 to 12
glb_for_x_1:

	move.w	#0,d1			;FOR y=0 to 9
glb_for_y_1:
	
	SetBoard #0		;LET board(x*10+y)=0

	move.w	d1,d2			;LET tmp=int((y-1)/2)*2+1
	subq.w	#1,d2
	divu.w	#2,d2
	mulu.w	#2,d2
	addq.w	#1,d2

	move.w	d0,d3			;LET tmpx=int((x-1)/2)*2+1
	subq.w	#1,d3
	divu.w	#2,d3
	mulu.w	#2,d3
	addq.w	#1,d3
	
	cmp.w	d1,d2			;IF y=tmp and x=tmpx then
	bne	glb_else_if_1
	cmp.w	d0,d3
	bne	glb_else_if_1

	SetBoard #2			;LET board(x*10+y)=2
	
	bra	glb_end_if_1

glb_else_if_1:
	move.w	d0,d3			;ELSE IF (y+x>3)
	add.w	d1,d3
	cmp.w	#2,d3
	bcs	glb_end_if_1

	Random  #3,d3			;IF (RND*3=1)
	cmp.w	#1,d3
	bne	glb_else_if_2

	SetBoard #1			;LET board(x*10+y)=1

	bra	glb_end_if_2

glb_else_if_2:

		move.w	d0,x
		move.w	d1,y
		move.w	#1,dir
	
		move.w	bomblib::game_difficulty,d4
		move.w	#15,d5
		sub.w	d4,d5

		Random  d5,d3			;IF (RND*8=1)
		cmp.w	#1,d3
		bne	glb_else_if_21


			bsr	add_enemy1
			bra	glb_end_if_2

	glb_else_if_21:

		cmp.w	#7,bomblib::level
		bcs	glb_end_if_2
		move.w	bomblib::game_difficulty,d4
		move.w	#25,d5
		sub.w	d4,d5

		Random  d5,d3			;IF (RND*8=1)
		cmp.w	#1,d3
		bne	glb_end_if_2

			bsr	add_enemy2

glb_end_if_2:
glb_end_if_1:
	addq.w	#1,d1			;NEXT y
	cmp.w	#10,d1
	bne	glb_for_y_1	

	addq.w	#1,d0			;NEXT x
	cmp.w	#13,d0
	bne	glb_for_x_1

	cmp.w	#0,bomblib::enemy1count
	beq		generate_level_board
	rts