;*******************************************Handle Bomb
;*
;*	called by mainloop to do processes on this bomb
;*
;*	Input:	d6=the # of this bonb in the bomb array
;*
;********
handle_bomb:

	lea	bomblib::bomb_x,a0		;Get bomb d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomblib::bomb_y,a0		;Get bomb d6's y
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	bomblib::bomb_s,a0		;Get bomb d6's s
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	lea	bomblib::bomb_es,a0		;Get bomb d6's es
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a5

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),es

	SetExtraPosInfo x,y

	move.w	x,d0		;clear the screen under the bomb
	move.w	y,d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	cmp.w	#1,bombs_are_triggered	;if bonbs are triggered, kill this one
	beq	delete_bomb

	cmp.w	#1,bomblib::trigger_bombs	;don't count down for triggers
	beq	no_timer_on_bomb
	subq.w	#1,es
	cmp.w	#0,es
	beq		delete_bomb
no_timer_on_bomb:

	addq.w	#1,s
	cmp.w	#4,s
	bne		hb_dont_reset
	move.w	#0,s
hb_dont_reset:

	;move.w	x,(a2)
	;move.w	y,(a3)
	move.w	s,(a4)
	move.w	es,(a5)

		;draw the bomb sprite
	cmp.w	#0,s
	beq		hb_s1
	cmp.w	#1,s
	beq		hb_s2
	cmp.w	#2,s
	beq		hb_s3
	cmp.w	#3,s
	beq		hb_s2
	rts

hb_s1:
	PutGray4Sprite sprite_bomb10,sprite_bomb11,x,y
	rts

hb_s2:
	PutGray4Sprite sprite_bomb20,sprite_bomb21,x,y
	rts

hb_s3:
	PutGray4Sprite sprite_bomb30,sprite_bomb31,x,y
	rts

;*******************************************Delete Bomb
;*
;*	Deletes a bomb from the bomb array
;*
;*	Input:	d6=the # of this bomb in the bomb array
;*
;********
delete_bomb:
	
	movem.l	d0-d3/a0-a3,-(a7)

		;add explosions downward
	clr.w	d2
	move.w	eblock_y,d1
	addq.w	#1,d1
	move.w	#0,tmp
db_add_vexp_down_loop:
	move.w	eblock_x,d0
	GetBoard d3
	cmp.w	#2,d3					;I hit undestr. wall
	beq		db_exit_add_vexp_down_loop
	cmp.w	#9,d1
	bhi		db_exit_add_vexp_down_loop
	cmp.w	bomblib::bomb_exp_len,d2
	beq		db_exit_add_vexp_down_loop
	cmp.w	#1,d3						;I hit a destructable wall
	beq		db_exit_add_vexp_down_loop_w_score_inc
	move.w	d0,x
	move.w	d1,y
	bsr		add_vexp
	cmp.w	#3,d3
	beq		db_exit_add_vexp_down_loop		;I hit a bomb
	addq.w	#1,d1
	addq.w	#1,d2
	bra		db_add_vexp_down_loop
db_exit_add_vexp_down_loop_w_score_inc:
	add.w	#10,bomblib::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_vexp_down_loop:

		;add explosions upwards
	clr.w	d2
	move.w	#1,tmp
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	subq.w	#1,d1
	cmp.w	#0,eblock_y
	beq		db_exit_add_vexp_up_loop
db_add_vexp_up_loop:
	GetBoard d3
	cmp.w	#2,d3
	beq		db_exit_add_vexp_up_loop
	cmp.w	bomblib::bomb_exp_len,d2
	beq		db_exit_add_vexp_up_loop
	cmp.w	#1,d3
	beq		db_exit_add_vexp_up_loop_w_score_inc
	move.w	d1,y
	move.w	d0,x
	bsr		add_vexp
	cmp.w	#3,d3
	beq		db_exit_add_vexp_up_loop		;I hit a bomb
	addq.w	#1,d2
	cmp.w	#0,d1
	beq		db_exit_add_vexp_up_loop
	subq.w	#1,d1
	bra		db_add_vexp_up_loop
db_exit_add_vexp_up_loop_w_score_inc:
	add.w	#10,bomblib::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_vexp_up_loop:

		;add explosions to the right
	clr.w	d2
	move.w	eblock_x,d0
	addq.w	#1,d0
	move.w	#0,tmp
db_add_hexp_right_loop:
	move.w	eblock_y,d1
	GetBoard d3
	cmp.w	#2,d3
	beq		db_exit_add_hexp_right_loop
	cmp.w	#12,d0
	bhi		db_exit_add_hexp_right_loop
	cmp.w	bomblib::bomb_exp_len,d2
	beq		db_exit_add_hexp_right_loop
	cmp.w	#1,d3
	beq		db_exit_add_hexp_right_loop_w_score_inc
	move.w	d0,x
	move.w	d1,y
	bsr		add_hexp
	cmp.w	#3,d3
	beq		db_exit_add_hexp_right_loop		;I hit a bomb
	addq.w	#1,d0
	addq.w	#1,d2
	bra		db_add_hexp_right_loop
db_exit_add_hexp_right_loop_w_score_inc:
	add.w	#10,bomblib::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_hexp_right_loop:

		;add explosions to the left
	clr.w	d2
	move.w	#1,tmp
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	subq.w	#1,d0
	cmp.w	#0,eblock_x
	beq		db_exit_add_hexp_left_loop
db_add_hexp_left_loop:
	GetBoard d3
	cmp.w	#2,d3
	beq		db_exit_add_hexp_left_loop
	cmp.w	bomblib::bomb_exp_len,d2
	beq		db_exit_add_hexp_left_loop
	cmp.w	#1,d3
	beq		db_exit_add_hexp_left_loop_w_score_inc
	move.w	d1,y
	move.w	d0,x
	bsr		add_hexp
	cmp.w	#3,d3
	beq		db_exit_add_hexp_left_loop		;I hit a bomb
	addq.w	#1,d2
	cmp.w	#0,d0
	beq		db_exit_add_hexp_left_loop
	subq.w	#1,d0
	bra		db_add_hexp_left_loop
db_exit_add_hexp_left_loop_w_score_inc:
	add.w	#10,bomblib::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_hexp_left_loop:

	move.w	eblock_x,x	;add xexp to where the bomb was
	move.w	eblock_y,y
	bsr		add_xexp

	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoard	#0

	lea	bomblib::bomb_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomblib::bomb_y,a1
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a1,d0.w),a1

	lea	bomblib::bomb_s,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	lea	bomblib::bomb_es,a3
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a3,d0.w),a3

	move.w	bomblib::bombcount,d0
	sub.w	d6,d0
	subq.w	#1,d0

		;shift the bomb array to cover the deleted bomb
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
	addq.w	#$02,a3
db_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2
	move.w	(a3),d0
	subq.w	#$02,a3
	move.w	d0,(a3)
	addq.w	#$04,a3

	dbra.w	d0,db_loop

	subq.w	#1,bomblib::bombcount

	movem.l	(a7)+,d0-d3/a0-a3
	rts

;*******************************************Add Bomb
;*
;*	called by mainloop to do processes on this bomb
;*
;*	Input:	x=the x-coordinate of the new bomb in blocks
;*		y=the y-coordinate of the new bomb in blocks
;*
;********
add_bomb:
	movem.l	d0-d2/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	cmp.w	#1,d2
	beq	cancel_add_bomb

	lea	bomblib::bomb_x,a0		;Set bomb x
	move.w  bomblib::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::bomb_y,a0		;Set bomb y
	move.w  bomblib::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	move.w	x,d0
	move.w	y,d1
	SetBoard	#3

	lea	bomblib::bomb_s,a0		;Set bomb s
	move.w  bomblib::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#0,(a0)

	lea	bomblib::bomb_es,a0		;Set bomb es
	move.w  bomblib::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomblib::bomblife,(a0)

	addq.w	#1,bomblib::bombcount

cancel_add_bomb:
	movem.l	(a7)+,d0-d2/a0
	rts