;*******************************************Handle Bonus
;*
;*	This function is called by mainloop to process a single instance of a bonus
;*
;*	Input:	d6=the # of this bonus in the bonus array
;*
;********
handle_bonus:

	lea	bomblib::bonus_x,a0		;Get bomb d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomblib::bonus_y,a0		;Get bomb d6's y
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	bomblib::bonus_t,a0		;Get bomb d6's s
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),t

	;SetExtraPosInfo x,y

	;move.w	x,d0
	;move.w	y,d1
	;moveq.w	#8,d2
	;moveq.w	#8,d3
	;moveq.w	#1,d4
	;move.l	graphlib::plane0,a1
	;jsr	graphlib::fill
	;move.l	graphlib::plane1,a1
	;jsr	graphlib::fill

		;display the bonus with the correct face
	cmp.w	#0,t
	beq		hb_t1
	cmp.w	#1,t
	beq		hb_t2
	cmp.w	#2,t
	beq		hb_t3
	cmp.w	#3,t
	beq		hb_t4
	cmp.w	#4,t
	beq		hb_t5
	cmp.w	#5,t
	beq		hb_t6
	cmp.w	#6,t
	beq		hb_t7
	cmp.w	#7,t
	beq		hb_t8
	cmp.w	#8,t
	beq		hb_t9
	rts

hb_t1:
	PutGray4Sprite sprite_bonus10,sprite_bonus11,x,y
	rts

hb_t2:
	PutGray4Sprite sprite_bonus20,sprite_bonus21,x,y
	rts

hb_t3:
	PutGray4Sprite sprite_bonus30,sprite_bonus31,x,y
	rts

hb_t4:
	PutGray4Sprite sprite_bonus40,sprite_bonus41,x,y
	rts

hb_t5:
	PutGray4Sprite sprite_bonus50,sprite_bonus51,x,y
	rts

hb_t6:
	PutGray4Sprite sprite_bonus60,sprite_bonus61,x,y
	rts

hb_t7:
	PutGray4Sprite sprite_bonus70,sprite_bonus71,x,y
	rts

hb_t8:
	PutGray4Sprite sprite_bonus80,sprite_bonus81,x,y
	rts

hb_t9:
	PutGray4Sprite sprite_bonus90,sprite_bonus91,x,y
	rts

;*******************************************Delete Bonus
;*
;*	This function deletes a bonus from the bonus array
;*
;*	Input:	d6=the bonus # in the bonus array
;*
;********
delete_bonus:

	movem.l	d0-d4/a0-a3,-(a7)

	lea	bomblib::bonus_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomblib::bonus_y,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	lea	bomblib::bonus_t,a3
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a3,d0.w),a3

	move.w	(a0),d0
	move.w	(a2),d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	move.w	bomblib::bonuscount,d0
	sub.w	d6,d0
	cmp.w	#0,d0
	beq		dbon_loop_exit
	subq.w	#1,d0

		;shift the bonus array to cover this deleted bonus
	addq.w	#$02,a0
	addq.w	#$02,a2
	addq.w	#$02,a3
dbon_loop:
	
	move.w	(a0),d1
	subq.w	#$02,a0
	move.w	d1,(a0)
	addq.w	#$04,a0
	move.w	(a2),d1
	subq.w	#$02,a2
	move.w	d1,(a2)
	addq.w	#$04,a2
	move.w	(a3),d1
	subq.w	#$02,a3
	move.w	d1,(a3)
	addq.w	#$04,a3

	dbra.w	d0,dbon_loop

dbon_loop_exit:
	subq.w	#1,bomblib::bonuscount

	movem.l	(a7)+,d0-d4/a0-a3
	rts

;*******************************************Add Bonus
;*
;*	Adds a bonus to the bonus array
;*
;*	Input:	t=the type of bonus
;*		x=the x-coordinate in blocks
;*		y=the y-coordinate in blocks
;*
;********
add_bonus:
	movem.l	d0-d2/a0,-(a7)

		;calculate if the bonus should be placed
	move.w	t,d1
	lea	bonus_chance(PC),a0
	mulu.w	#$2,d1
	lea	0(a0,d1.w),a0
	move.w	(a0),d1
	Random	d1,d2
	cmp.w	#1,d2
	bne	add_bonus_cancel

	lea	bomblib::bonus_x,a0		;Set vexp x
	move.w  bomblib::bonuscount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::bonus_y,a0		;Set vexp y
	move.w  bomblib::bonuscount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::bonus_t,a0		;Set vexp s
	move.w  bomblib::bonuscount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	t,(a0)

	addq.w	#1,bomblib::bonuscount

add_bonus_cancel:
	movem.l	(a7)+,d0-d2/a0
	rts