;*******************************************Get Enemy 2 Stats
;*
;*	Gather pointers for a certain enemy
;*
;*	Input:	d6=the number of this enemy in the enemy arrays
;*
;*	Output:	a2=pointer to x coordinate
;*		a3=pointer to y coordinate
;*		a4=pointer to sprite info
;*		a5=pointer to enemy direction
;*
;********
bomblib@0005:
learn_enemy2:
	lea	enemy2_x(PC),a0		;Get enemy2 d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	enemy2_y(PC),a0		;Get enemy2 d6's y
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	enemy2_s(PC),a0		;Get enemy2 d6's s
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	lea	enemy2_d(PC),a0		;Get enemy2 d6's d
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a5
	rts

;*******************************************Move Enemy2
;*
;*	Move an enemy
;*
;*	Input:	a2=pointer to x coordinate
;*		a3=pointer to y coordinate
;*		a4=pointer to sprite info
;*		a5=pointer to enemy direction
;*
;********
bomblib@0006:
move_enemy2:
	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),dir
	SetExtraPosInfo x,y

	addq.w	#1,s
	cmp.w	#3,s
	bne		me2_no_reset_s
	move.w	#0,s
me2_no_reset_s:

	cmp.w	#5,erelpos_x		;IF relpos_x=5
	bne		me2_else_1
	cmp.w	#5,erelpos_y		;and relpos_y=5
	bne		me2_else_1
	Random  #5,d3			;and (RND*5=1)
	cmp.w	#1,d3
	bne	me2_else_1

		Random  #4,d3
		move.w	d3,dir

		bra		me2_end_if_1

me2_else_1:

		cmp.w	#1,dir			;IF dir(a)=1 then
		bne		me2_else_if_11

			cmp.w	#5,erelpos_x		;IF relpos_x>5 or relpos_x<5 then
			beq		me2_else_101


				subq.w	#1,x

				bra		me2_end_if_1

		me2_else_101:

			cmp.w	#0,eblock_x		;IF block_x=0
			beq	me2_if_1011
			move.w	eblock_x,d0		;or board((block_x-1)*10+block_y)<>0
			subq.w	#1,d0
			move.w	eblock_y,d1
			GetBoardL d2
			cmp.w	#0,d2
			bne	me2_if_1011
			
				subq.w	#1,x
				bra		me2_end_if_1

			me2_if_1011:

				move.w	#4,dir
				bra		me2_end_if_1

	me2_else_if_11:

		cmp.w	#2,dir			;IF dir(a)=2 then
		bne		me2_else_if_12

			cmp.w	#5,erelpos_x		;IF relpos_x>5 or relpos_x<5 then
			beq		me2_else_111


				addq.w	#1,x

				bra		me2_end_if_1

		me2_else_111:

			cmp.w	#12,eblock_x		;IF block_x=12
			beq		me2_if_1111
			move.w	eblock_x,d0		;or board((block_x+1)*10+block_y)<>0
			addq.w	#1,d0
			move.w	eblock_y,d1
			GetBoardL d2
			cmp.w	#0,d2
			bne	me2_if_1111
			
				addq.w	#1,x
				bra		me2_end_if_1

			me2_if_1111:

				move.w	#3,dir
				bra		me2_end_if_1

	me2_else_if_12:

		cmp.w	#3,dir			;IF dir(a)=3 then
		bne		me2_else_if_13

			cmp.w	#5,erelpos_y		;IF relpos_y>5 or relpos_y<5 then
			beq		me2_else_121


				addq.w	#1,y

				bra		me2_end_if_1

		me2_else_121:

			cmp.w	#9,eblock_y		;IF block_y=9
			beq		me2_if_1211
			move.w	eblock_x,d0		;or board((block_x)*10+block_y+1)<>0
			move.w	eblock_y,d1
			addq.w	#1,d1
			GetBoardL d2
			cmp.w	#0,d2
			bne	me2_if_1211
			
				addq.w	#1,y
				bra		me2_end_if_1

			me2_if_1211:

				move.w	#1,dir
				bra		me2_end_if_1

	me2_else_if_13:

		cmp.w	#4,dir			;IF dir(a)=4 then
		bne		me2_end_if_1

			cmp.w	#5,erelpos_y		;IF relpos_y>5 or relpos_y<5 then
			beq		me2_else_131


				subq.w	#1,y

				bra		me2_end_if_1

		me2_else_131:

			cmp.w	#0,eblock_y		;IF block_y=0
			beq		me2_if_1311
			move.w	eblock_x,d0		;or board((block_x)*10+block_y-1)<>0
			move.w	eblock_y,d1
			subq.w	#1,d1
			GetBoardL d2
			cmp.w	#0,d2
			bne	me2_if_1311
			
				subq.w	#1,y
				bra		me2_end_if_1

			me2_if_1311:

				move.w	#2,dir
				bra		me2_end_if_1

me2_end_if_1:

	move.w	x,(a2)
	move.w	y,(a3)
	move.w	s,(a4)
	move.w	dir,(a5)
	rts

;*******************************************Delete enemy2
;*
;*	Delete an enemy
;*
;*	Input:	d6=number of this enemy in the enemy array
;*
;********
bomblib@0007:
delete_enemy2:
	
	movem.l	d0-d4/a0-a4,-(a7)

	lea	enemy2_x(PC),a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	enemy2_y(PC),a4
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a4,d0.w),a4

	move.w	(a0),d0
	move.w	(a4),d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	lea	enemy2_s(PC),a2
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	lea	enemy2_d(PC),a3
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a3,d0.w),a3

	move.w	enemy2count,d0
	sub.w	d6,d0
	subq.w	#1,d0

	addq.w	#$02,a0
	addq.w	#$02,a4
	addq.w	#$02,a2
	addq.w	#$02,a3
denemy2_loop:
	
	move.w	(a0),d1
	subq.w	#$02,a0
	move.w	d1,(a0)
	addq.w	#$04,a0
	move.w	(a4),d1
	subq.w	#$02,a4
	move.w	d1,(a4)
	addq.w	#$04,a4
	move.w	(a2),d1
	subq.w	#$02,a2
	move.w	d1,(a2)
	addq.w	#$04,a2
	move.w	(a3),d1
	subq.w	#$02,a3
	move.w	d1,(a3)
	addq.w	#$04,a3

	dbra.w	d0,denemy2_loop

	subq.w	#1,enemy2count

	movem.l	(a7)+,d0-d4/a0-a4
	rts