;*******************************************Score Displaying Idle Wait
;*
;*	This function displays the scores on the main screen until a key is pressed
;*	wherein the function will return the key in d0
;*
;********
bomblib@0003:
score_idle_loop:
		clr.w    tios::kb_vars+$1c          ; Clear keypress counter
		tst.w    tios::kb_vars+$1c          ; See if a keypress is stored
		bne.s    score_idle_loop            ; Continue waiting if not
score_idle_loop2:
		bra		sil_disp_score1
		sil_displayed_score1:
		bra		sil_disp_score2
		sil_displayed_score2:
		bra		sil_disp_score3
		sil_displayed_score3:
		bra		sil_disp_score4
		sil_displayed_score4:
		bra		sil_disp_score5
		sil_displayed_score5:
		bra		sil_disp_score6
		sil_displayed_score6:
		bra		sil_disp_score7
		sil_displayed_score7:
		bra		sil_disp_score8
		sil_displayed_score8:

		move.l	#60000,d0
score_idle_delay:
		nop
		nop
		nop
		nop
		dbra.l	d0,score_idle_delay

		tst.w    tios::kb_vars+$1c          ; See if a keypress is stored
		beq.s    score_idle_loop2           ; Continue waiting if not
		clr.w    tios::kb_vars+$1c          ; Clear keypress counter
		move.w   tios::kb_vars+$1e,d0       ; Read keypress
		rts

	GenetateScoreDisplayingCode	1
	GenetateScoreDisplayingCode	2
	GenetateScoreDisplayingCode	3
	GenetateScoreDisplayingCode	4
	GenetateScoreDisplayingCode	5
	GenetateScoreDisplayingCode	6
	GenetateScoreDisplayingCode	7
	GenetateScoreDisplayingCode	8

;*******************************************Check High Score
;*
;*	This function compares the player's score with the high scores, first asking
;*	the player's name
;*
;********
bomblib@0004
check_high_score:
	move.w	score,d0
	cmp.w	high_score8n,d0
	ble		chs_exit

	lea		high_score_text,a0
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	lea		high_score_text,a0
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	WriteStr	#36,#40,#1,ask_name_text

	move.w	#0,graphlib::choosescreen	;set all graphlib functions to grayscale mode
	clr.w   (tios::kb_vars+$1c)    ; test is a key was hit

	movem.l	d0-d3/a0-a2,-(a7)
	SetFont #1
	clr.l	d0
	move.w	#36,d1
	move.w	#52,d2
	move.w	#10,d3
	move.w	#0,d4
	jsr		userlib::InputStr
	lea		name(PC),a2
	add.l	#1,d0
	move.l	d0,-(a7)
	move.l	a0,-(a7)
	move.l	a2,-(a7)
	jsr		tios::strncpy
	lea		12(a7),a7
	movem.l	(a7)+,d0-d3/a0-a2

	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

	move.w	score,d0
	move.w	scoreh,d1

	cmp.w	high_score1h,d1
	bcc		chs_1n
not_bigger_score1h:
	cmp.w	high_score2h,d1
	bcc		chs_2n
not_bigger_score2h:
	cmp.w	high_score3h,d1
	bcc		chs_3n
not_bigger_score3h:
	cmp.w	high_score4h,d1
	bcc		chs_4n
not_bigger_score4h:
	cmp.w	high_score5h,d1
	bcc		chs_5n
not_bigger_score5h:
	cmp.w	high_score6h,d1
	bcc		chs_6n
not_bigger_score6h:
	cmp.w	high_score7h,d1
	bcc		chs_7n
not_bigger_score7h:
	cmp.w	high_score8h,d1
	bcc		chs_8n
	bra		chs_exit

chs_1n:
	cmp.w	high_score1n,d0
	bcs		not_bigger_score1h
	move.w	high_score7l,high_score8l
	move.w	high_score6l,high_score7l
	move.w	high_score5l,high_score6l
	move.w	high_score4l,high_score5l
	move.w	high_score3l,high_score4l
	move.w	high_score2l,high_score3l
	move.w	high_score1l,high_score2l
	move.w	level,high_score1l
	move.w	high_score7n,high_score8n
	move.w	high_score6n,high_score7n
	move.w	high_score5n,high_score6n
	move.w	high_score4n,high_score5n
	move.w	high_score3n,high_score4n
	move.w	high_score2n,high_score3n
	move.w	high_score1n,high_score2n
	move.w	score,high_score1n
	move.w	high_score7h,high_score8h
	move.w	high_score6h,high_score7h
	move.w	high_score5h,high_score6h
	move.w	high_score4h,high_score5h
	move.w	high_score3h,high_score4h
	move.w	high_score2h,high_score3h
	move.w	high_score1h,high_score2h
	move.w	scoreh,high_score1h
	CopyStr	high_score7,high_score8,#10
	CopyStr	high_score6,high_score7,#10
	CopyStr	high_score5,high_score6,#10
	CopyStr	high_score4,high_score5,#10
	CopyStr	high_score3,high_score4,#10
	CopyStr	high_score2,high_score3,#10
	CopyStr	high_score1,high_score2,#10
	CopyStr	name(PC),high_score1,#10
	bra		chs_exit

chs_2n:
	cmp.w	high_score2n,d0
	bcs		not_bigger_score2h
	move.w	high_score7l,high_score8l
	move.w	high_score6l,high_score7l
	move.w	high_score5l,high_score6l
	move.w	high_score4l,high_score5l
	move.w	high_score3l,high_score4l
	move.w	high_score2l,high_score3l
	move.w	level,high_score2l
	move.w	high_score7n,high_score8n
	move.w	high_score6n,high_score7n
	move.w	high_score5n,high_score6n
	move.w	high_score4n,high_score5n
	move.w	high_score3n,high_score4n
	move.w	high_score2n,high_score3n
	move.w	score,high_score2n
	move.w	high_score7h,high_score8h
	move.w	high_score6h,high_score7h
	move.w	high_score5h,high_score6h
	move.w	high_score4h,high_score5h
	move.w	high_score3h,high_score4h
	move.w	high_score2h,high_score3h
	move.w	scoreh,high_score2h
	CopyStr	high_score7,high_score8,#10
	CopyStr	high_score6,high_score7,#10
	CopyStr	high_score5,high_score6,#10
	CopyStr	high_score4,high_score5,#10
	CopyStr	high_score3,high_score4,#10
	CopyStr	high_score2,high_score3,#10
	CopyStr	name(PC),high_score2,#10
	bra		chs_exit

chs_3n:
	cmp.w	high_score3n,d0
	bcs		not_bigger_score3h
	move.w	high_score7l,high_score8l
	move.w	high_score6l,high_score7l
	move.w	high_score5l,high_score6l
	move.w	high_score4l,high_score5l
	move.w	high_score3l,high_score4l
	move.w	level,high_score3l
	move.w	high_score7n,high_score8n
	move.w	high_score6n,high_score7n
	move.w	high_score5n,high_score6n
	move.w	high_score4n,high_score5n
	move.w	high_score3n,high_score4n
	move.w	score,high_score3n
	move.w	high_score7h,high_score8h
	move.w	high_score6h,high_score7h
	move.w	high_score5h,high_score6h
	move.w	high_score4h,high_score5h
	move.w	high_score3h,high_score4h
	move.w	scoreh,high_score3h
	CopyStr	high_score7,high_score8,#10
	CopyStr	high_score6,high_score7,#10
	CopyStr	high_score5,high_score6,#10
	CopyStr	high_score4,high_score5,#10
	CopyStr	high_score3,high_score4,#10
	CopyStr	name(PC),high_score3,#10
	bra		chs_exit

chs_4n:
	cmp.w	high_score4n,d0
	bcs		not_bigger_score4h
	move.w	high_score7l,high_score8l
	move.w	high_score6l,high_score7l
	move.w	high_score5l,high_score6l
	move.w	high_score4l,high_score5l
	move.w	level,high_score4l
	move.w	high_score7n,high_score8n
	move.w	high_score6n,high_score7n
	move.w	high_score5n,high_score6n
	move.w	high_score4n,high_score5n
	move.w	score,high_score4n
	move.w	high_score7h,high_score8h
	move.w	high_score6h,high_score7h
	move.w	high_score5h,high_score6h
	move.w	high_score4h,high_score5h
	move.w	scoreh,high_score4h
	CopyStr	high_score7,high_score8,#10
	CopyStr	high_score6,high_score7,#10
	CopyStr	high_score5,high_score6,#10
	CopyStr	high_score4,high_score5,#10
	CopyStr	name(PC),high_score4,#10
	bra		chs_exit

chs_5n:
	cmp.w	high_score5n,d0
	bcs		not_bigger_score5h
	move.w	high_score7l,high_score8l
	move.w	high_score6l,high_score7l
	move.w	high_score5l,high_score6l
	move.w	level,high_score5l
	move.w	high_score7n,high_score8n
	move.w	high_score6n,high_score7n
	move.w	high_score5n,high_score6n
	move.w	score,high_score5n
	move.w	high_score7h,high_score8h
	move.w	high_score6h,high_score7h
	move.w	high_score5h,high_score6h
	move.w	scoreh,high_score5h
	CopyStr	high_score7,high_score8,#10
	CopyStr	high_score6,high_score7,#10
	CopyStr	high_score5,high_score6,#10
	CopyStr	name(PC),high_score5,#10
	bra		chs_exit

chs_6n:
	cmp.w	high_score6n,d0
	bcs		not_bigger_score6h
	move.w	high_score7l,high_score8l
	move.w	high_score6l,high_score7l
	move.w	level,high_score6l
	move.w	high_score7n,high_score8n
	move.w	high_score6n,high_score7n
	move.w	score,high_score6n
	move.w	high_score7h,high_score8h
	move.w	high_score6h,high_score7h
	move.w	scoreh,high_score6h
	CopyStr	high_score7,high_score8,#10
	CopyStr	high_score6,high_score7,#10
	CopyStr	name(PC),high_score6,#10
	bra		chs_exit

chs_7n:
	cmp.w	high_score7n,d0
	bcs		not_bigger_score7h
	move.w	high_score7l,high_score8l
	move.w	level,high_score7l
	move.w	high_score7n,high_score8n
	move.w	score,high_score7n
	move.w	high_score7h,high_score8h
	move.w	scoreh,high_score7h
	CopyStr	high_score7,high_score8,#10
	CopyStr	name(PC),high_score7,#10
	bra		chs_exit

chs_8n:
	cmp.w	high_score8n,d0
	bcs		chs_exit
	move.w	level,high_score8l
	move.w	score,high_score8n
	move.w	scoreh,high_score8h
	CopyStr	name(PC),high_score8,#10
	bra		chs_exit

chs_exit:
	rts