;*******************************************Handle X Explosion
;*
;*	This functions handles an x explosion(looks like a plus +)
;*
;*	Input	d6=the xexp explosion # in the array
;*
;*********
handle_xexp:

	lea	bomblib::xexp_x,a0		;Get xexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomblib::xexp_y,a0		;Get xexp d6's y
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a3

	lea	bomblib::xexp_s,a0		;Get xexp d6's s
	;move.w  d6,d2
	;mulu.w	#2,d2
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s

	move.w	x,d0			;clear the screen for its location
	move.w	y,d1
	moveq.w	#8,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_xexp

	;move.w	x,(a2)
	;move.w	y,(a3)
	move.w	s,(a4)

		;draw the xexp sprite
	cmp.w	#1,s
	beq		hxe_s2
	cmp.w	#2,s
	beq		hxe_s3
	cmp.w	#3,s
	beq		hxe_s4
	cmp.w	#4,s
	beq		hxe_s3
	cmp.w	#5,s
	beq		hxe_s2
	bra		delete_xexp
	rts

hxe_s2:
	PutGray4Sprite sprite_xexp20,sprite_xexp21,x,y
	rts

hxe_s3:
	PutGray4Sprite sprite_xexp30,sprite_xexp31,x,y
	rts

hxe_s4:
	PutGray4Sprite sprite_xexp40,sprite_xexp41,x,y
	rts

;*******************************************Delete X Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the xexp array
;*
;*********
delete_xexp:

	movem.l	d0/a0-a2,-(a7)

	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoard	#0

	lea	bomblib::xexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomblib::xexp_y,a1
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a1,d0.w),a1

	lea	bomblib::xexp_s,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	move.w	bomblib::xexpcount,d0
	sub.w	d6,d0
	cmp.w	#0,d0
	beq		dxe_loop_exit
	subq.w	#1,d0

		;this code shifts the array one less starting at the posiion of this sprite
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
dxe_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2

	dbra.w	d0,dxe_loop

dxe_loop_exit:
	subq.w	#1,bomblib::xexpcount

	movem.l	(a7)+,d0/a0-a2
	rts

;*******************************************Add X Explosion
;*
;*	This functions adds an x explosion to the xexp array
;*
;*	Input:	x=x coordinate(in squares) of the new xexp
;*		y=y coordinate(in squares) of the new xexp
;*
;*********
add_xexp:
	movem.l	d0-d2/a0,-(a7)

	lea	bomblib::xexp_x,a0		;Set xexp x
	move.w  bomblib::xexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::xexp_y,a0		;Set xexp y
	move.w  bomblib::xexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#9,d2
	addq.w	#5,d2
	move.w	d2,(a0)

	lea	bomblib::xexp_s,a0		;Set xexp s
	move.w  bomblib::xexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomblib::explife,(a0)

	movem.l	(a7)+,d0-d2/a0

	addq.w	#1,bomblib::xexpcount
	rts